<template>
  <button
    v-if="beneficiaryDocumentFolderId"
    class="fr-btn open-modal-btn"
    data-fr-opened="false"
    aria-controls="global-modal"
    type="button"
    @click="onAdd"
  >
    Ajouter un document
  </button>
</template>

<script setup>
  import BeneficiaryDocumentAddForm from './BeneficiaryDocumentAddForm.vue'
  import { useDocumentsStore } from '~~/store/documents'

  const { $modal } = useNuxtApp()
  const documentsStore = useDocumentsStore()

  const props = defineProps({
    beneficiaryId: { type: String, required: true }
  })

  const emit = defineEmits(['added'])

  const { data: beneficiaryDocumentFolderId } = useLazyAsyncData(
    'beneficiaryDocumentFolderId',
    loadBeneficiaryDocumentsFolderId,
    { server: false }
  )

  async function loadBeneficiaryDocumentsFolderId() {
    return await documentsStore.loadBeneficiaryDocumentsFolderId()
  }

  function onAdd() {
    $modal.open(
      'Ajouter un document',
      BeneficiaryDocumentAddForm,
      {
        beneficiaryId: props.beneficiaryId,
        beneficiaryDocumentFolderId: beneficiaryDocumentFolderId.value
      },
      { added: onDocumentAdded }
    )
  }

  function onDocumentAdded(document) {
    emit('added', document)
  }
</script>

<style scoped>
  .open-modal-btn {
    border-radius: 2rem;
  }
</style>
